package utopp;
// H.B
//v0.1
//NEU: 27.12.00 nderung der MenBar zuweisung auf setJMenuBar
//NEU: 30.12.00 nderungen fr das Diagram Panel

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

import java.io.*;
import java.util.*;
import java.text.*;
import java.beans.*;

import utopp.gui.*;
import utopp.modell.*;
import utopp.xml.*;

public class MainFrame extends JFrame implements ActionListener
  {
    //MenSystem
  GridBagConstraints myGBC;
  JMenuBar jmbMainMenu;
  JFileChooser jfcDatei = new JFileChooser("c:/projekte");
  
  InternalFramePanel lpListenPanel;
  
  JInternalFrame[] frameArray;
  
  UmlProjekt aktuellesProjekt = new UmlProjekt();
  
  private int frameArrayLength;
  private String mainFrameTitle;
 
  public static void main(String[] args)
    {
    new MainFrame();
    }

  //Kontruktor
  public MainFrame()
    {
    initGUI();
    }
  //Initialisierungs Methode
  void initGUI()
    {
      //Fenster Icon
    ImageIcon frameImageIcon = new ImageIcon("images/UseCase.gif");
    Image frameImage = frameImageIcon.getImage();
    this.setIconImage(frameImage);
    this.mainFrameTitle="U-Topp   GREENHORN Ltd.";
    this.setTitle(mainFrameTitle);
      //Allgemein fr JFrame
    this.getContentPane().setLayout(new GridBagLayout());
    myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
    addWindowListener(new ExitListener());
      //Grsse und Position
    Toolkit tk = Toolkit.getDefaultToolkit();
    Dimension d = tk.getScreenSize();
    int sH = d.height;
    int sW = d.width;
    int frameWidth=sW-(sW/4);
    int frameHeight=sH-(sH/4);
    this.setSize(frameWidth,frameHeight);
    this.setLocation(sW/8,sH/16);
      //MenuBar
    jmbMainMenu = new JMenuBar();
      //Men Datei
    jmbMainMenu.add(makeMenu("Datei",new Object[]{"Neues Projekt","Projekt ffnen"
                    ,"Projekt speichern","Projekt speichern unter","Exit"},this));
      //Men Bearbeiten
    JMenu jmAnsicht = new JMenu("Bearbeiten");
      JCheckBoxMenuItem pflichtenheft = new JCheckBoxMenuItem("Pflichtenheft");
      pflichtenheft.addActionListener(this);
    jmAnsicht.add(pflichtenheft);
      JCheckBoxMenuItem klassenListe = new JCheckBoxMenuItem("Klassen");
      klassenListe.addActionListener(this);
    jmAnsicht.add(klassenListe);
      JCheckBoxMenuItem assoziationenListe = new JCheckBoxMenuItem("Assoziationen");
      assoziationenListe.addActionListener(this);
    jmAnsicht.add(assoziationenListe);
      JCheckBoxMenuItem useCaseliste = new JCheckBoxMenuItem("UseCases");
      useCaseliste.addActionListener(this);
    jmAnsicht.add(useCaseliste);
    jmAnsicht.addSeparator();
      JCheckBoxMenuItem diagramFrame = new JCheckBoxMenuItem("Diagramm");
      diagramFrame.addActionListener(this);
    jmAnsicht.add(diagramFrame);
    jmAnsicht.addSeparator();
    JMenuItem jmiListenAnordnen = new JMenuItem("Fenster anordnen");
    jmiListenAnordnen.addActionListener(this);
    jmAnsicht.add(jmiListenAnordnen);
    jmbMainMenu.add(jmAnsicht);
      //Men Hilfe
    jmbMainMenu.add(makeMenu("Hilfe",new Object[]{"E-Mail","Helpline"},this));  
    this.setJMenuBar(jmbMainMenu);
      //Menu Zustand VOR existenz eines Projektes.
    jmbMainMenu.getMenu(1).setEnabled(false);
    jmbMainMenu.getMenu(0).getItem(2).setEnabled(true);
    jmbMainMenu.getMenu(0).getItem(3).setEnabled(true);
      //ListenPanel hinzufgen
    lpListenPanel = new InternalFramePanel(aktuellesProjekt);
    add(lpListenPanel,myGBC,0,0,1,1,100,100);
    frameArray = lpListenPanel.getAllFrames();
    frameArrayLength = frameArray.length;
    this.setVisible(true);
    }

  public void add(Component c, GridBagConstraints gbc, int x, int y, int w, int h, int wx, int wy)
    {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weightx = wx;
    gbc.weighty = wy;
    this.getContentPane().add(c, gbc);
    }


  //Hilfsmethode zum erstellen von Mens
  public static JMenu makeMenu(Object parent, Object[] items, Object target)
    {
    JMenu m = null;
    if(parent instanceof JMenu)
      m = (JMenu)parent;
    else if(parent instanceof String)
      m = new JMenu((String)parent);
    else 
      return null;
    for(int i=0; i<items.length; i++)
      {
      if(items[i]==null)
        m.addSeparator();
      else
        m.add(makeMenuItem(items[i], target));
      }
    return m;
    }//end makeMenu(...)

  //Hilfsmethode zum Erstellen von Mens
  public static JMenuItem makeMenuItem(Object item, Object target)
    {
    JMenuItem r = null;
    if(item instanceof String)
      r = new JMenuItem((String)item);
    else if(item instanceof JMenuItem)
      r = (JMenuItem)item;
    else
      return null;
    if(target instanceof ActionListener)
      r.addActionListener((ActionListener)target);
    return r;
    }//end makeMenuItem


  //FehlerMeldungen
  void fehlerMeldung(String art, String verursacher)
    {
    if(art.equals("UseCaseError1"))
      {
      JOptionPane.showMessageDialog(this
      ,"Ach du Scheisse: \nDen UseCase gibts schon:  "+verursacher+" \nDie Eingaben werden verworfen."
      ,"FEHLER",JOptionPane.ERROR_MESSAGE,new ImageIcon("Error1.gif"));
      }
    }


  void listenAnordnen()
    {
    try{
    String sErgebnis= new String();
    boolean[] bVisibleFrames=new boolean[]{frameArray[0].isVisible(),frameArray[1].isVisible()
                                          ,frameArray[2].isVisible(),frameArray[3].isVisible()
                                          ,frameArray[4].isVisible()};
    int numberOfVisible=0;
    for(int i=0;i<frameArrayLength;i++)
      {
      if(bVisibleFrames[i])
        numberOfVisible++;
      }
    int[] iVB = new int[numberOfVisible];
    int found=0;
    for(int j=0;j<frameArrayLength;j++)
      {
      if(bVisibleFrames[j])
        {
        iVB[found]=j;
        sErgebnis=sErgebnis+j+" ";
        found++;
        }
      }
    anordnen(iVB);
    }//end try
    catch(NullPointerException g){System.out.println("Resize-Ausnahme beim Oeffnen des MainWindow."
                                                      +"\nMethode listenAnordnen() wird nicht ausgefuehrt.");}
    }//end listenAnordnen


  void anordnen(int[] frames)
    {
    int lpW = lpListenPanel.getWidth();
    int lpH = lpListenPanel.getHeight();
    if(frames.length==1)
      frameArray[frames[0]].reshape(0,0,lpH,lpH);
    else if(frames.length==2)
      {
      frameArray[frames[0]].reshape(0,0,lpH,lpH-40);
      frameArray[frames[1]].reshape(40,40,lpH,lpH-40);
      }     
    else if(frames.length==3)
      {
      frameArray[frames[0]].reshape(0,0,lpH,lpH-80);
      frameArray[frames[1]].reshape(40,40,lpH,lpH-80);
      frameArray[frames[2]].reshape(80,80,lpH,lpH-80);
      }
    else if(frames.length==4)
      {
      frameArray[frames[0]].reshape(0,0,lpH,lpH-120);
      frameArray[frames[1]].reshape(40,40,lpH,lpH-120);
      frameArray[frames[2]].reshape(80,80,lpH,lpH-120);
      frameArray[frames[3]].reshape(120,120,lpH,lpH-120);
      }
    else if(frames.length==5)
      {
      frameArray[frames[0]].reshape(0,0,lpH,lpH-160);
      frameArray[frames[1]].reshape(40,40,lpH,lpH-160);
      frameArray[frames[2]].reshape(80,80,lpH,lpH-160);
      frameArray[frames[3]].reshape(120,120,lpH,lpH-160);
      frameArray[frames[4]].reshape(160,160,lpH,lpH-160);
      }
    }//end anordnen
  

  public void actionPerformed(ActionEvent e)
    {
    if(e.getSource() instanceof JMenuItem)
      {
      String command = e.getActionCommand();
        //Men Datei
      if(command.equals("Exit"))
        System.exit(0);
      else if(command.equals("Neues Projekt"))
        {
        String projektName = JOptionPane.showInputDialog(this,"Name des neuen Projekts:","Neues Projekt",JOptionPane.QUESTION_MESSAGE); 
        if((!(projektName==null))&&(!(projektName.equals(""))))
          {
          this.setTitle(mainFrameTitle+"            PROJEKT: "+projektName);
          aktuellesProjekt = new UmlProjekt();
          aktuellesProjekt.setName(projektName);
          lpListenPanel.setData(aktuellesProjekt);
          jmbMainMenu.getMenu(1).setEnabled(true);
          }
        else if(!(projektName==null))
          JOptionPane.showMessageDialog(this,"Ach du Scheisse:\nDer Name geht ja wohl gar nicht !!","FEHLER",JOptionPane.ERROR_MESSAGE); 
        }
      else if (command.equals("Projekt ffnen"))
	  {

	    if (jfcDatei.showOpenDialog(this)==JFileChooser.APPROVE_OPTION)
		try{  
		  XmlReader r = new XmlReader(new FileInputStream(jfcDatei.getSelectedFile()));
          aktuellesProjekt.xmlRead(r);
		  lpListenPanel.setData(aktuellesProjekt);
		}
		catch(FileNotFoundException fnfe){}
		catch(IOException ioe){};
		
	  }
      else if(command.equals("Projekt speichern"))
       saveProjekt(new File(aktuellesProjekt.getName()));
      else if(command.equals("Projekt speichern unter"))        
	  	if (jfcDatei.showSaveDialog(this)==JFileChooser.APPROVE_OPTION)
          saveProjekt(jfcDatei.getSelectedFile());
        //Men Hilfe
      else if(command.equals("E-Mail"))
        System.out.println("Not yet implemented");
      else if(command.equals("Helpline"))
        {
        System.out.println("Alle dem Projekt bekannten UseCases:");
        UmlUseCaseListe uucl = aktuellesProjekt.getUseCaseliste();
        Iterator it1 = uucl.iterator();
        while(it1.hasNext())
          System.out.println(((UmlUseCase)it1.next()).getName());
        
        System.out.println();
        System.out.println(aktuellesProjekt.getDiagramCollection());
        }
        //Men Bearbeiten
      else if(command.equals("Pflichtenheft"))
        {
        boolean bListState =((JCheckBoxMenuItem)jmbMainMenu.getMenu(1).getMenuComponent(0)).getState();
        if(bListState)
          {
          frameArray[0].setVisible(true);
          listenAnordnen();
          }
        else
          {
          frameArray[0].setVisible(false);
          listenAnordnen();
          }
        }
      else if(command.equals("Klassen"))
        {
        boolean bListState =((JCheckBoxMenuItem)jmbMainMenu.getMenu(1).getMenuComponent(1)).getState();
        if(bListState)
          {
          frameArray[1].setVisible(true);
          listenAnordnen();
          }
        else
          {
          frameArray[1].setVisible(false);
          listenAnordnen();
          }
        }
      else if(command.equals("Assoziationen"))
        {
        boolean bListState =((JCheckBoxMenuItem)jmbMainMenu.getMenu(1).getMenuComponent(2)).getState();
        if(bListState)
          {
          frameArray[2].setVisible(true);
          listenAnordnen();
          }
        else
          {
          frameArray[2].setVisible(false);
          listenAnordnen();
          }
        }
      else if(command.equals("UseCases"))
        {
        boolean bListState =((JCheckBoxMenuItem)jmbMainMenu.getMenu(1).getMenuComponent(3)).getState();
        if(bListState)
          {
          frameArray[3].setVisible(true);
          listenAnordnen();
          }
        else
          {
          frameArray[3].setVisible(false);
          listenAnordnen();
          }
        }
      else if(command.equals("Diagramm"))
        {
        boolean bListState =((JCheckBoxMenuItem)jmbMainMenu.getMenu(1).getMenuComponent(5)).getState();
        if(bListState)
          {
          frameArray[4].setVisible(true);
          listenAnordnen();
          }
        else
          {
          frameArray[4].setVisible(false);
          listenAnordnen();
          }
        }
      else if(command.equals("Fenster anordnen"))
        listenAnordnen();
      else
        System.out.println("Fehler: "+e.getActionCommand()+" wurde kein Eventhandler zugeordnet");
      }
   }//end actionPerformed

  class ExitListener extends WindowAdapter
    {
    public void windowClosing(WindowEvent e)
      {
      System.exit(0);
      }
    }//end class ExitListener  
	
	
  public void saveProjekt(File f){
    try{
	  XmlWriter w = new XmlWriter(new FileOutputStream(f));
	  lpListenPanel.getData(aktuellesProjekt);
      aktuellesProjekt.xmlWrite(w,0);
	  w.flush();
	  w.close();
    }		
	catch(FileNotFoundException fnfe){} 
	catch(IOException ioe){System.out.println(ioe);}
  }	 
	
  } //end class MainFrame