package utopp.diagram;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import utopp.gui.*;
import utopp.modell.*;


public class DiagramDialog extends JDialog implements ActionListener
  {
  final int MR_OK = 0;
  final int MR_CANCEL = 1; 
  int modalResult = MR_CANCEL;  
  private JButton jbOk;
  private JButton jbCancel;
  private DiagramListPanel dlp;
 
  public DiagramDialog(Frame parent, String title) 
    {
    super(parent, title, true);
    JPanel jpPane = new JPanel(new BorderLayout());
    this.setContentPane(jpPane);
    jpPane.add(getButtonPanel(), BorderLayout.SOUTH);
    buildGUI();
    pack();
    }
	
  public DiagramDialog()
    {
    this(null, "");
    }
	
  int showDialog(DiagramCollection data)
    {
    setFields(data);
    show();
    if(modalResult == MR_OK)
      return dlp.getSelectedDiagram();
    else
      return -1;
    }//end showDialog

  public void setFields(DiagramCollection data)
    {
    dlp.setData(data);
    }

  private JPanel getButtonPanel()
    {
    JPanel jpButtons = new JPanel(new FlowLayout());
    jbOk= ComponentFactory.getJButton("Ok", this);
    jpButtons.add(jbOk);
    jbCancel= ComponentFactory.getJButton("Abbrechen",this);
    jpButtons.add(jbCancel);
    JPanel jpBottom = new JPanel(new BorderLayout());
    jpBottom.add(jpButtons, BorderLayout.EAST);
    return jpBottom;
    }
	
  public void actionPerformed(ActionEvent e) 
    {	  	
    if (e.getSource()==jbOk)
      modalResult = MR_OK;
    else
      modalResult = MR_CANCEL; 
    hide();  
    }
	
  private void buildGUI()
    {
    //Fenster Einstellungen
    Toolkit tk = Toolkit.getDefaultToolkit();
    Dimension d = tk.getScreenSize();
    int sH = d.height;
    int sW = d.width;
    this.setLocation((sW-350)/2,(sH-600)/2);
    dlp = new DiagramListPanel();
    this.getContentPane().add(dlp, BorderLayout.NORTH);
    this.setResizable(false);
    }
	

  }//end class DiagramDialog


