package utopp.diagram;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import utopp.gui.*;
import utopp.modell.*;

public class DiagramListPanel extends JPanel implements ListSelectionListener
  {
  DiagramCollection dc;
  GridBagConstraints myGBC;
  JScrollPane jspListScrollPane;
  JScrollPane jspTableScrollPane;
  DefaultTableModel defTabMod = new DefaultTableModel();
  JTable jtDataTable;
  JList jlDiagramList;
  JLabel jlDiagramme;
  JLabel jlDiagramObjects;

  public DiagramListPanel(DiagramCollection dc)
    {
    super();
    erzeugeTabelle();
    buildGUI();
    this.dc=dc;
    }
  
  public DiagramListPanel()
    {
    this(null);
    }
  
  private void buildGUI()
    {
      //Allgemein
    this.setLayout(new GridBagLayout());
    myGBC = new GridBagConstraints();
      //Labels
    jlDiagramme = new JLabel("Diagramme:");
    add(this,jlDiagramme,myGBC,GridBagConstraints.BOTH,0,0,1,1,100,0);
    jlDiagramObjects = new JLabel("Enthaltene Objekte:");
    add(this,jlDiagramObjects,myGBC,GridBagConstraints.BOTH,1,0,1,1,100,0);
      //List in ScrollPane
    jlDiagramList = new JList();
    jlDiagramList.addListSelectionListener(this);
    jspListScrollPane = new JScrollPane(jlDiagramList);
    add(this,jspListScrollPane,myGBC,GridBagConstraints.BOTH,0,1,1,1,50,100);
      //Diagram Daten in Tabelle in ScrollPane
    jspTableScrollPane = new JScrollPane(jtDataTable);
    add(this,jspTableScrollPane,myGBC,GridBagConstraints.BOTH,1,1,1,1,100,100);
      //Allgemein
    this.setPreferredSize(new Dimension(400,300));
    this.setMinimumSize(new Dimension(400,300));
    this.setMaximumSize(new Dimension(400,300));
    }

  public void valueChanged(ListSelectionEvent e)
    {
    clearTable();
    Iterator diagramItr = ((Diagram)(jlDiagramList.getSelectedValue())).iterator();
    while (diagramItr.hasNext())
      {
      DiagramObject dobj = (DiagramObject)diagramItr.next();
      Object[] spalten = new Object[2];
      spalten[0]=new String(dobj.getName());
      spalten[1]=new String(dobj.getUmlObjectType());
      defTabMod.addRow(spalten);
      }
    }

  public void clearTable()
    {
    while(defTabMod.getRowCount()>0)
      defTabMod.removeRow(0);
    }

  public void setData(DiagramCollection dc)
    {
    this.dc=dc;
    jlDiagramList.setListData(dc);
    }

  public int getSelectedDiagram()
    {
    return jlDiagramList.getSelectedIndex();
    }

  public void erzeugeTabelle()
    {
    defTabMod.setColumnCount(2);
    Object[] colNames = {"Name","Uml-Objekt-Typ"};
    defTabMod.setColumnIdentifiers(colNames);
    jtDataTable = new JTable(defTabMod);
    }

  public void add(Container target, Component c, GridBagConstraints gbc,int filling, int x, int y, int w, int h, int wx, int wy)
    {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weightx = wx;
    gbc.weighty = wy;
    gbc.fill = filling;
    target.add(c, gbc);
    }
  }//end class DiagramListPanel