package utopp.diagram;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import utopp.gui.*;
import utopp.modell.*;
import utopp.modell.event.*;

public class DiagramManagementPanel extends JPanel implements ActionListener
  {
  private GridBagConstraints myGBC;
  private JComboBox jcbKlassen,jcbAssoziationen,jcbUseCases;
  private JLabel jlKlassen,jlAssoziationen,jlUseCases;
  private UmlUseCaseListe uucl = new UmlUseCaseListe();
  private UmlAssoziationsListe ual = new UmlAssoziationsListe();
  private UmlKlassenListe ukl = new UmlKlassenListe();
  private JLabel jlInsert;
  private JLabel jlName;
  private Diagram aktualDiagram=new Diagram();
  private DiagramObjectsChangeListener docl;
  
  public DiagramManagementPanel(Diagram aktualDiagram)
    {
    super();
    initGUI();
    this.aktualDiagram=aktualDiagram;
    docl=null;
    }

  public void initGUI()
    {
      //Allgemein
    this.setLayout(new GridBagLayout());
    this.setBackground(Color.gray.darker().darker());
    myGBC = new GridBagConstraints();
      //ComboBoxen
    jcbKlassen = new JComboBox();
    jcbKlassen.addActionListener(this);
    jcbAssoziationen = new JComboBox();
    jcbAssoziationen.addActionListener(this);
    jcbUseCases = new JComboBox();
    jcbUseCases.addActionListener(this);
    add(this,jcbKlassen,myGBC,GridBagConstraints.BOTH,1,1,1,1,100,100);
    add(this,jcbAssoziationen,myGBC,GridBagConstraints.BOTH,2,1,1,1,100,100);
    add(this,jcbUseCases,myGBC,GridBagConstraints.BOTH,3,1,1,1,100,100);
      //Labels
    jlKlassen = new JLabel("Klassen:");
    jlKlassen.setForeground(Color.white);
    add(this,jlKlassen,myGBC,GridBagConstraints.BOTH,1,0,1,1,100,100);
    jlAssoziationen = new JLabel("Assoziationen:");
    jlAssoziationen.setForeground(Color.white);
    add(this,jlAssoziationen,myGBC,GridBagConstraints.BOTH,2,0,1,1,100,100);
    jlUseCases = new JLabel("UseCases:");
    jlUseCases.setForeground(Color.white);
    add(this,jlUseCases,myGBC,GridBagConstraints.BOTH,3,0,1,1,100,100);
      //JLabel Einfgen
    jlInsert = new JLabel("Einfuegen in:");
    jlInsert.setForeground(Color.white);
    add(this,jlInsert,myGBC,GridBagConstraints.BOTH,0,0,1,1,100,100);
      //Label DiagramName
    jlName = new JLabel("<name>");
    jlName.setForeground(Color.red);
    add(this,jlName,myGBC,GridBagConstraints.BOTH,0,1,1,1,100,100);
    }

  public void setActualDiagram(Diagram d)
    {
    this.aktualDiagram=d;
    this.jlName.setText(d.getName());
    }

  public void actionPerformed(ActionEvent ae)
    {
    if(ae.getActionCommand().equals("selecting"))
      {
      Object buffer = ((JComboBox)ae.getSource()).getSelectedItem();
      //UseCases
      if(buffer instanceof UmlUseCase)
        if(!(((UmlUseCase)buffer).getName().equals("<name>")))
          {
          try{
            aktualDiagram.addDiagramObject(((UmlUseCase)buffer).getDiagramObject());}
          catch(ElementExistiertException e){}
          }
      //Klassen
      if(buffer instanceof UmlKlasse)
        if(!(((UmlKlasse)buffer).getName().equals("<name>")))
          {
          try{
            aktualDiagram.addDiagramObject(((UmlKlasse)buffer).getDiagramObject());}
          catch(ElementExistiertException e){}
          }
      //Assoziationen
      if(buffer instanceof UmlAssoziation)
        if(!(((UmlAssoziation)buffer).getName().equals("<name>")))
          {
  /*        try{
            aktualDiagram.addDiagramObject(((UmlAssoziation)buffer).getDiagramObject());}
          catch(ElementExistiertException e){}*/
          }
      if(docl!=null)
        docl.diagramObjectsChanged();
      }
    }//end actionPerformed

  public void setData(UmlProjekt up)
    {
    if(up!=null)
      {
      //UseCases
      jcbUseCases.setActionCommand("updating");
      uucl=up.getUseCaseliste();
      jcbUseCases.removeAllItems();
      Iterator listItr = uucl.iterator();
      while(listItr.hasNext())
        {
        jcbUseCases.addItem(listItr.next());
        }
      jcbUseCases.setActionCommand("selecting");
      //Assoziationen
      jcbAssoziationen.setActionCommand("updating");
      ual=up.getAssoziationsliste();
      jcbAssoziationen.removeAllItems();
      Iterator listItr2 = ual.iterator();
      while(listItr2.hasNext())
        {
        jcbAssoziationen.addItem(listItr2.next());
        }
      jcbAssoziationen.setActionCommand("selecting");
      //Klassen
      jcbKlassen.setActionCommand("updating");
      ukl=up.getKlassenliste();
      jcbKlassen.removeAllItems();
      Iterator listItr3 = ukl.iterator();
      while(listItr3.hasNext())
        {
        jcbKlassen.addItem(listItr3.next());
        }
      jcbKlassen.setActionCommand("selecting");
      }//end if not null
    else 
      System.out.println("DiagramManagementPanel: setData(..): FEHLER: projekt Objekt null!");
    }//end setData()

  public void addDiagramObjectsChangeListener(DiagramObjectsChangeListener docl)
    {
    this.docl=docl;
    }

  public void add(Container target, Component c, GridBagConstraints gbc,int filling, int x, int y, int w, int h, int wx, int wy)
    {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weightx = wx;
    gbc.weighty = wy;
    gbc.fill = filling;
    target.add(c, gbc);
    }

  }//end class DiagramManagementPanel