package utopp.diagram;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import utopp.gui.*;
import utopp.modell.*;

public class DiagramObject
  {
  private String name;
  private String umlObjectType;
  private BufferedImage buffIm;
  private int xPosInDiagram;
  private int yPosInDiagram;
  private final int maxWidth=2000;
  private final int maxHeight=2000;

  public DiagramObject(BufferedImage bi, String name, String umlObjectType)
    {
    this.name=name;
    this.umlObjectType=umlObjectType;
    this.buffIm=bi;
    this.xPosInDiagram = 0;
    this.yPosInDiagram = 0;
    }

  public String getName()
    {
    return name;
    }

  public void setUmlObjectType(String uot)
    {
    this.umlObjectType=uot;
    }

  public String getUmlObjectType()
    {
    return this.umlObjectType;
    }

  public BufferedImage getBufferedImage()
    {
    return this.buffIm;
    }

  public Dimension getLocationInDiagram()
    {
    return new Dimension(xPosInDiagram,yPosInDiagram);
    }

  public int getXPosInDiagram()
    {
    return xPosInDiagram;
    }

  public int getYPosInDiagram()
    {
    return yPosInDiagram;
    }

  public void setName(String name)
    {
    this.name=name;
    }

  public void setBufferedImage(BufferedImage buffIm)
    {
    this.buffIm=buffIm;
    }

  public void setLocationInDiagram(int x, int y)
    {
    //Kontrolle von X
    if(x<0)
      this.xPosInDiagram=0;
    else if((x+buffIm.getWidth())>maxWidth)
      this.xPosInDiagram=maxWidth-buffIm.getWidth();
    else
      this.xPosInDiagram=x;
    //Kontrolle von Y
    if(y<0)
      this.yPosInDiagram=0;
    else if((y+buffIm.getHeight())>maxHeight)
      this.yPosInDiagram=maxHeight-buffIm.getHeight();
    else
      this.yPosInDiagram=y;
    }
 
  public void setXPosInDiagram(int x)
    {
    this.xPosInDiagram=x;
    }
  
  public void setYPosInDiagram(int y)
    {
    this.yPosInDiagram=y;
    }

  public boolean isMouseOver(int xPos, int yPos)
    {
    return ((xPos>xPosInDiagram)&&(yPos>yPosInDiagram)&&(xPos<(buffIm.getWidth()+xPosInDiagram))&&(yPos<(buffIm.getHeight()+yPosInDiagram)));
    }

  public String toString()
    {
    return name;
    }

  }//end class DiagramObject