package utopp.diagram;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import utopp.gui.*;
import utopp.modell.*;
import utopp.modell.event.*;

public class DiagrammFrame extends JInternalFrame implements ActionListener,DiagramObjectsChangeListener
  {
  ZeichenBrett brett;
  JButton DiagrammFrameSomething; 
  JScrollPane baseArea;
  JMenuBar jmbDiagramMenu;
  private UmlProjekt projekt;
  private DiagramManagementPanel dmp;
  private Diagram aktualDiagram = new Diagram();
  private final int zeichenBrettSize=2000;
 
  public DiagrammFrame()
    {
    initGUI();
    }

  public void initGUI()
    {
      //MenuBar fr das Fenster
    jmbDiagramMenu = new JMenuBar();
     JMenu jmDiagram= new JMenu("Diagramm");
       JMenuItem jmiNewDiagram=new JMenuItem("Neues Diagramm");
       jmiNewDiagram.addActionListener(this);
       jmDiagram.add(jmiNewDiagram);
       JMenuItem jmiOpenDiagram=new JMenuItem("Diagramm ffnen");
       jmiOpenDiagram.addActionListener(this);
       jmDiagram.add(jmiOpenDiagram);
    jmbDiagramMenu.add(jmDiagram);
    
      //Frame allgemein
    this.setTitle("Diagramm");
    this.setResizable(true);
    this.setMaximizable(true);
    this.setIconifiable(true);
    this.setJMenuBar(jmbDiagramMenu);
    this.getContentPane().setLayout(new GridBagLayout());
    GridBagConstraints myGBC = new GridBagConstraints();
      //ZeichenBrett im ScrollPane
    brett = new ZeichenBrett(aktualDiagram);
    brett.setMinimumSize(new Dimension(zeichenBrettSize,zeichenBrettSize));
    brett.setPreferredSize(new Dimension(zeichenBrettSize,zeichenBrettSize));
    brett.setMaximumSize(new Dimension(zeichenBrettSize,zeichenBrettSize));
    baseArea = new JScrollPane(brett,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    baseArea.setVisible(false);
    add(this.getContentPane(),baseArea,myGBC,GridBagConstraints.BOTH,0,1,1,1,100,100);
      //DiagramManagamentPanel
    dmp = new DiagramManagementPanel(aktualDiagram);
    dmp.setVisible(false);
    dmp.addDiagramObjectsChangeListener(this);
    add(this.getContentPane(),dmp,myGBC,GridBagConstraints.HORIZONTAL,0,0,1,1,100,0);
    }

  public void setData(UmlProjekt up)
    {
    this.projekt=up;
    //Diagramm Fenster wird unsichtbar geschaltet falls neu
    if(projekt.getDiagramCollection().size()==0)
      {
      baseArea.setVisible(false);
      dmp.setVisible(false);
      }
    dmp.setData(projekt);
    }

  public void actionPerformed(ActionEvent e)
    {
    if(e.getActionCommand().equals("Neues Diagramm"))
      {
      try{
        String diagramName = JOptionPane.showInputDialog(this,"Name des neuen Diagrams:","Neues Diagram",JOptionPane.QUESTION_MESSAGE); 
        if((diagramName!=null)&&(!diagramName.equals(""))) 
          {
          aktualDiagram = new Diagram(diagramName);
          projekt.getDiagramCollection().addDiagram(aktualDiagram);
          brett.setActualDiagram(aktualDiagram);
          dmp.setActualDiagram(aktualDiagram);
          diagramObjectsChanged();
          baseArea.setVisible(true);
          dmp.setVisible(true);
          }}
      catch(ElementExistiertException eee)
        {JOptionPane.showMessageDialog(this,"Ach du Scheisse: \nDer Name ist bereits vergeben! "
                                       ,"FEHLER:",JOptionPane.ERROR_MESSAGE);}
      }
    else if(e.getActionCommand().equals("Diagramm ffnen"))
      {
      DiagramDialog dd = new DiagramDialog(null,"Diagram ffnen:");
      int index=-1;
      index = dd.showDialog(projekt.getDiagramCollection());
      if(!(index==-1))
        {
        try{
          aktualDiagram = projekt.getDiagramCollection().getElementAt(index);
          brett.setActualDiagram(aktualDiagram);
          dmp.setActualDiagram(aktualDiagram);
          diagramObjectsChanged();
          baseArea.setVisible(true);
          dmp.setVisible(true);}
        catch(ElementExistiertNichtException tripleE){}
        }
      this.repaint();  
      }      
    //DiagramMenu
    }

  public void diagramObjectsChanged()
    {
    brett.repaint();
    }

  public void add(Container target, Component c, GridBagConstraints gbc,int filling, int x, int y, int w, int h, int wx, int wy)
    {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weightx = wx;
    gbc.weighty = wy;
    gbc.fill = filling;
    target.add(c, gbc);
    }

  }//end class DiagrammFrame