package utopp.diagram;

import java.awt.*;
import java.awt.image.*;

/**Dieses Inteface soll einem UmlObject die Fhigkeit verleihen von sich selbst ein Abbild
   fr ein Diagramm zu erzeugen.
*/
public interface Viewable
  {
  public BufferedImage getImage();
    //Diese Methode soll ein BufferedImage erzeugen.
    //Dazu benutzt sie die Methode createPicture welche das Graphics2D Object als Argument
    //bekommt, welches man mittels BufferedImage.createGraphics() erzeugt.
  public DiagramObject getDiagramObject();
    //Diese Methode besteht nur aus einer Zeile:
    //return new DiagramObject(getImage(),"ein Name");
    //entsprechend der Signatur von DiagramObject(...)
  public void createPicture(Graphics2D g);
    //Diese Methode zeichnet mit dem erhaltenen Graphics2D kontext den
    //eigentlichen Inhalt des Bildes, das schliesslich das UmlObject
    //reprsentieren soll.
  }