package utopp.diagram;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import utopp.gui.*;
import utopp.modell.*;



public class ZeichenBrett extends JPanel implements ActionListener,MouseMotionListener,MouseListener
  {
  private boolean dragged=false;
  private DiagramObject draggingOne=null;
  private int deleteOneIndex=-1;
  private Diagram aktualDiagram=new Diagram();  
  private int xDiff=0;
  private int yDiff=0;
  private JPopupMenu jpmDiagram;

  public ZeichenBrett(Diagram aktualDiagram)
    {
    super();
    init();
    this.aktualDiagram=aktualDiagram;
    }

  public void init()
    {
    addMouseMotionListener(this);
    addMouseListener(this);
    jpmDiagram=new JPopupMenu();
    JMenuItem jmiDelete = new JMenuItem("Aus Diagramm entfernen");
    jmiDelete.addActionListener(this);
    jpmDiagram.add(jmiDelete);
    }

  public void paintComponent(Graphics g)
    {
    super.paintComponent(g);
    Iterator it = aktualDiagram.iterator();
    while(it.hasNext())
      {
      DiagramObject buff1 = (DiagramObject) it.next();
      BufferedImage buff2 = (BufferedImage) buff1.getBufferedImage();
      g.drawImage(buff2,buff1.getXPosInDiagram(),buff1.getYPosInDiagram(),null);
      }
    }//end paintComponent

  public void setActualDiagram(Diagram d)
    {
    this.aktualDiagram=d;
    }

  public void actionPerformed(ActionEvent ae)
    {
    //System.out.println(deleteOneIndex);
    aktualDiagram.removeElementAt(deleteOneIndex);
    this.repaint();
    deleteOneIndex=-1;
    }

  public void mouseDragged(MouseEvent evt)
    {
    if(draggingOne!=null)
      {
      draggingOne.setLocationInDiagram(evt.getX()-xDiff,evt.getY()-yDiff);
      this.repaint();
      }
    else
      {
      Iterator it2 = aktualDiagram.iterator();
      while(it2.hasNext())
        {
        DiagramObject obj = (DiagramObject) it2.next();
        if(obj.isMouseOver(evt.getX(),evt.getY()))
          {
          xDiff=evt.getX()-obj.getXPosInDiagram();
          yDiff=evt.getY()-obj.getYPosInDiagram();
          draggingOne=obj;
          }
        }
      }//end else
    }//end mouseDragged

  public void mouseMoved(MouseEvent evt)
    {
    }

  public void mouseReleased(MouseEvent evt)
    {
    draggingOne=null;
    xDiff=0;
    yDiff=0;
    if(evt.isPopupTrigger())
      {
      Iterator it3 = aktualDiagram.iterator();
      int i=-1;
      while(it3.hasNext())
        {
        i++;
        DiagramObject obj = (DiagramObject) it3.next();
        if(obj.isMouseOver(evt.getX(),evt.getY()))
          {
          jpmDiagram.show(evt.getComponent(),evt.getX(),evt.getY());
          deleteOneIndex=i;
          }
        }
      }
    }//end mouseReleased

  public void mouseClicked(MouseEvent evt)
    {
    }

  public void mouseEntered(MouseEvent evt)
    {
    }

  public void mouseExited(MouseEvent evt)
    {
    }

  public void mousePressed(MouseEvent evt)
    {
    }

  }//end class ZeichenBrett