//NEU:	30.12.00 Hinzufgen des DiagrammFrame
//NEU:  01.01.01 diagrammUdateListener fr alle Panels

package utopp.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import utopp.modell.*;
import utopp.gui.klassenframe.*;
import utopp.gui.assoziationsframe.*;
import utopp.gui.usecaseframe.*;
import utopp.gui.pflichtenheft.*;
import utopp.diagram.*;

public class InternalFramePanel extends JDesktopPane implements DiagramUpdateListener
  {
  private UmlProjekt projekt;
  
  private JInternalFrame jifPflichtenheft;
  private PflichtenheftDataPanel pfdPflichten;
  
  private JInternalFrame jifKlassen;
  private ListControlPanel lcpKlassen;  
  
  private JInternalFrame jifAssoziationen;
  private ListControlPanel lcpAssoziationen;  
  
  private JInternalFrame jifUseCases;
  private ListControlPanel lcpUseCases;

  private DiagrammFrame jifDiagram; 

  public InternalFramePanel(UmlProjekt up)
    {
    initGUI();
    setData(up);
    }
  
  public void addInternalFrame(JInternalFrame fr, String name, ImageIcon imIc, DataPanel pnl)
    {
    fr = new JInternalFrame(name,true,false,true,true);
    fr.setFrameIcon(imIc);
    fr.getContentPane().add(pnl);
	fr.pack();
    fr.setVisible(false);
    this.add(fr);
    }

  void initGUI()
    {
    ImageIcon iiUseCase = new ImageIcon("images/UseCase.gif"); 
    //Pflichtenheft
    pfdPflichten = new PflichtenheftDataPanel();
    this.addInternalFrame(jifPflichtenheft, "Pflichtenheft", iiUseCase, pfdPflichten); 
    //Klassen
    ClassDataPanel cdp = new ClassDataPanel();
    cdp.addDiagramUpdateListener(this);
    lcpKlassen = new ListControlPanel(new UmlKlassenListe(), cdp);
    lcpKlassen.addDiagramUpdateListener(this);
    this.addInternalFrame(jifKlassen, "Klassen", iiUseCase, lcpKlassen);
    //Assoziationen
	lcpAssoziationen = new AssControlPanel(this);
    this.addInternalFrame(jifAssoziationen, "Assoziationen", iiUseCase, lcpAssoziationen); 
     //UseCases
    UseCaseDataPanel ucdp = new UseCaseDataPanel();
    ucdp.addDiagramUpdateListener(this);
    lcpUseCases = new ListControlPanel(new UmlUseCaseListe(),ucdp);
    lcpUseCases.addDiagramUpdateListener(this);
    this.addInternalFrame(jifUseCases, "UseCases", new ImageIcon("images/usecaselist.gif"), lcpUseCases);	
    //Diagramm Frame
    jifDiagram = new DiagrammFrame();
    //jifDiagram.addDiagramUpdateListener(this);
    jifDiagram.setVisible(false);
    this.add(jifDiagram);
    //Allgemein
    this.setVisible(true);
    this.setBackground(Color.darkGray);
    }

  public void updateDiagram()
    {
    System.out.println("DiagramUpdateListener: Updating Diagram...");
    jifDiagram.setData(projekt);
    }

  public void setData(UmlProjekt pr)
    {
    this.projekt=pr;
    pfdPflichten.setData(pr.getPflichtenheft());
    lcpKlassen.setData(pr.getKlassenliste());
    lcpAssoziationen.setData(pr.getAssoziationsliste());
    lcpUseCases.setData(pr.getUseCaseliste());
    jifDiagram.setData(pr);
    }  

  public void getData(UmlProjekt pr)
    {
    pfdPflichten.getData(pr.getPflichtenheft());
	pr.setKlassenliste((UmlKlassenListe) lcpKlassen.getObject());
	pr.setAssoziationsliste((UmlAssoziationsListe) lcpAssoziationen.getObject());
	pr.setUseCaseliste((UmlUseCaseListe) lcpUseCases.getObject());
    }      

  public UmlProjekt getProjekt()
    {
    UmlProjekt h = new UmlProjekt();
    getData(h);
    return h;
    }

  public String toString()
    {
    return "InternalFramePanel: DiagramUpdateListener.";
    }
  
  }//end class InternalFramePanel