package utopp.gui.assoziationsframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class BinaerAssAllgPanel extends DataPanel
{

  JTextField jtfName;
  JComboBox jcobStereotyp;
  JComboBox jcobRichtung;
  JComboBox jcobTyp;
  JTextArea jtaZusicherungen;
  JTextArea jtaEigenschaften;
  
  public BinaerAssAllgPanel()
  {
    super();
	initGUI();		 
  }
  
  public void setData(Object data)
  {	 
     UmlBinaerAssoziation h = (UmlBinaerAssoziation) data;
	 this.jcobStereotyp.setSelectedItem(h.getStereotyp());
	 this.jcobTyp.setSelectedItem(h.getTyp());
     this.jtfName.setText(h.getName());
	 this.jcobRichtung.setSelectedItem(h.getRichtung()); 
	 this.jtaZusicherungen.setText(h.getZusicherung());
	 this.jtaEigenschaften.setText(h.getEigenschaften());
	 showing = data;
  }
  
  public void getData(Object item){
  	UmlBinaerAssoziation h = (UmlBinaerAssoziation) item;
    h.setStereotyp((String)jcobStereotyp.getSelectedItem()); 
	h.setTyp((String)jcobTyp.getSelectedItem()); 
	h.setName(jtfName.getText()); 
	h.setRichtung((String)jcobRichtung.getSelectedItem());
	h.setZusicherung(jtaZusicherungen.getText());
	h.setEigenschaften(jtaEigenschaften.getText());	
  };
  
  public Object getObject(){
  
    UmlBinaerAssoziation h = new UmlBinaerAssoziation(
	  (String)jcobStereotyp.getSelectedItem(), 
	  (String)jcobTyp.getSelectedItem(), 
	  jtfName.getText(), 
	  (String)jcobRichtung.getSelectedItem(),
	  jtaZusicherungen.getText(),
	  jtaEigenschaften.getText()	  
	  );
	return (Object) h;  
  
  }
  
  public Object getDummy(){
    return new UmlBinaerAssoziation("","Assoziation", "<name>","ungerichtet","","");  
  }
	
  void initGUI()
  { 
	    GridBagConstraints myGBC = new GridBagConstraints();
	    myGBC.fill = GridBagConstraints.BOTH;
		
		myGBC.insets = NORMAL;
	      //Hinzufgen der Komponenten
		 
	      add(new JLabel("Stereotyp"), myGBC, 0, 0, 1, 1, 100, 0);
	      jcobStereotyp = ComponentFactory.getStereotypCombo();
	      add(jcobStereotyp, myGBC, 1, 0, 1, 1, 100, 0);
		  
	      add(new JLabel("Assoziationstyp"), myGBC, 2, 0, 1, 1, 100, 0);
	      jcobTyp = ComponentFactory.getAssoziationstypCombo();
	      add(jcobTyp, myGBC, 3, 0, 1, 1, 100, 0);
		  
 	      add(new JLabel("Beschriftung"), myGBC, 0, 1, 1, 1, 100, 0);
	      jtfName = new JTextField();
	      add(jtfName, myGBC, 1,1, 1, 1, 100, 0);
		  
	      add(new JLabel("Richtung"), myGBC, 2, 1, 1, 1, 100, 0);
	      jcobRichtung = ComponentFactory.getRichtungCombo();
	      add(jcobRichtung, myGBC, 3, 1, 1, 1, 100, 0);
		  
		  myGBC.insets = OBEN;
	      add(new JLabel("Zusicherungen"), myGBC, 0, 4, 1, 1, 100, 0);
  	      add(new JLabel("Eigenschaften"), myGBC, 2, 4, 1, 1, 100, 0);
		  
		  myGBC.insets = NORMAL;
	      jtaZusicherungen = new JTextArea(6,20);		  
	      add(new JScrollPane(jtaZusicherungen), myGBC, 0, 5, 2, 4, 0, 100);
		  
	      jtaEigenschaften = new JTextArea(6,20);		  
	      add(new JScrollPane(jtaEigenschaften), myGBC, 2, 5, 2, 4, 0, 100);
  }

}