package utopp.gui.assoziationsframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class RollenDataPanel extends DataPanel
{  
  JComboBox jcobKlasse;
  JTextField jtfName;
  JComboBox jcobKardinalitaet; 
  
  private static UmlKlassenListe vKlassen = new UmlKlassenListe();
				
  public RollenDataPanel()
  {
    super();
	initGUI();		 
  }
  
  public RollenDataPanel(String title){
    this();
    this.setBorder(BorderFactory.createTitledBorder(title));
  }
  
  public RollenDataPanel(String title, UmlAssRolle rolle){
    this(title);
	this.setData(rolle);
  }
  
  public static void setKlassen(UmlKlassenListe klassen){
    vKlassen = klassen;
  }
  
  public void setData(Object data)
  {
   	 UmlAssRolle h = (UmlAssRolle) data;
	 this.jcobKlasse.setSelectedItem(h.getKlasse());
     this.jtfName.setText(h.getName());
	 this.jcobKardinalitaet.setSelectedItem(h.getKardinalitaet());
	 showing = data;
  }
  
  public void getData(Object item){
    UmlAssRolle h = (UmlAssRolle) item;
	h.setKlasse((UmlKlasse)jcobKlasse.getSelectedItem());
	h.setName(jtfName.getText());
	h.setKardinalitaet((String)jcobKardinalitaet.getSelectedItem());
  }
  
  public Object getObject(){
    return new UmlAssRolle((UmlKlasse)jcobKlasse.getSelectedItem(), 
							jtfName.getText(), (String)jcobKardinalitaet.getSelectedItem());
  
  }
 
  public Object getDummy(){
    return new UmlAssRolle(null,"<name>","1");
  }
  	
  void initGUI()
  {
      //Einstellung des Layouts
    GridBagConstraints myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
	myGBC.insets = NORMAL;
	
    add(new JLabel("Klasse"), myGBC,0,0,1,1,100,0);	  
    jcobKlasse = new JComboBox(vKlassen);
	jcobKlasse.addActionListener(this);
    add(jcobKlasse, myGBC,1,0,1,1,100,0);	
	
    jtfName = new JTextField();
	jtfName.addActionListener(this);
    add(new JLabel("Name"), myGBC,0,1,1,1,100,0);	          
    add(jtfName, myGBC,1,1,1,1,100,0);	  
	  
    add(new JLabel("Kardinalitaet"), myGBC,0,2,1,1,100,0);    
	jcobKardinalitaet = ComponentFactory.getKardinalitaetCombo();
	jcobKardinalitaet.addActionListener(this);
    add(jcobKardinalitaet, myGBC,1,2,1,1,100,0);
	  
    add(ComponentFactory.getJButton("bernehmen", this), myGBC, 0,3,1,1,100,0);
  }

}