package utopp.gui.klassenframe;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class AttributeDataPanel extends DataPanel
{ 
   JComboBox jcobSichtbarkeit;
   JComboBox jcobTyp;
   JTextField jtfName;   
   JTextField jtfInitialwert;
   JTextArea jtaZusicherung;
   JTextArea jtaEigenschaften;
   JTextArea jtaAbhaengigkeit; 
				
  public AttributeDataPanel()
  {
    super();
	
	initGUI();		 
  }
  
  public void setData(Object data)
  {  UmlAttribut h = (UmlAttribut) data;
  	 jcobSichtbarkeit.setSelectedItem(h.getSichtbarkeit());	 
  	 jcobTyp.setSelectedItem(h.getTyp());
  	 jtfName.setText(h.getName());
  	 jtfInitialwert.setText(h.getInitialwert());
  	 jtaZusicherung.setText(h.getZusicherung());
  	 jtaEigenschaften.setText(h.getEigenschaften());
  	 jtaAbhaengigkeit.setText(h.getAbhaengigkeit());
	 showing = data;	  
  }
  
  public void getData(Object item){
  	UmlAttribut h = (UmlAttribut) item;
  	h.setTyp((String) jcobTyp.getSelectedItem()); 
	h.setName(jtfName.getText()); 
	h.setSichtbarkeit((String) jcobSichtbarkeit.getSelectedItem()); 
	h.setInitialwert(jtfInitialwert.getText()); 
	h.setZusicherung(jtaZusicherung.getText()); 
	h.setEigenschaften(jtaEigenschaften.getText()); 
	h.setAbhaengigkeit(jtaAbhaengigkeit.getText());
  }
  
  public Object getObject(){ 
  	return new UmlAttribut((String) jcobTyp.getSelectedItem(), 
									 jtfName.getText(), 
									 (String) jcobSichtbarkeit.getSelectedItem(), 
									 jtfInitialwert.getText(), 
									 jtaZusicherung.getText(), 
									 jtaEigenschaften.getText(), 
									 jtaAbhaengigkeit.getText());
  }
 
  
  public Object getDummy(){
    return new UmlAttribut("int","<name>","default","","","","");
  }
  	
  void initGUI()
    {
      //Einstellung des Layouts
    GridBagConstraints myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
	
	myGBC.insets = NORMAL;
	    	  
      add(new JLabel("Sichtbarkeit"), myGBC,0,0,1,1,100,0);
      jcobSichtbarkeit = ComponentFactory.getSichtbarkeitCombo();
	  jcobSichtbarkeit.addActionListener(this);
      add(jcobSichtbarkeit, myGBC,1,0,1,1,100,0);
	  
      add(new JLabel("Rckgabetyp"), myGBC,0,1,1,1,100,0);
      jcobTyp = ComponentFactory.getTypCombo();
	  jcobTyp.addActionListener(this);
      add(jcobTyp, myGBC,1,1,1,1,100,0);
	  
      add(new JLabel("Name"), myGBC,0,2,1,1,100,0);
      jtfName = new JTextField();
	  jtfName.addActionListener(this);
      add(jtfName, myGBC,1,2,1,1,100,0);
	  	  	  
      add(new JLabel("Initialwert"), myGBC,0,3,1,1,100,0);	  
      jtfInitialwert = new JTextField();
	  jtfInitialwert.addActionListener(this);
      add(jtfInitialwert, myGBC,1,3,1,1,100,0);
	  
      add(new JLabel("Zusicherungen"), myGBC,0,4,1,1,100,0);
      jtaZusicherung = ComponentFactory.getArea();
      add(ComponentFactory.getScrollPane(jtaZusicherung), myGBC,1,4,1,2,100,100);

      add(new JLabel("Eigenschaften"), myGBC,0,6,1,1,100,0);
      jtaEigenschaften = ComponentFactory.getArea();
      add(ComponentFactory.getScrollPane(jtaEigenschaften), myGBC,1,6,1,2,100,100);

      add(new JLabel("Abhngigkeit"), myGBC,0,8,1,1,100,0);
      jtaAbhaengigkeit = ComponentFactory.getArea();
      add(ComponentFactory.getScrollPane(jtaAbhaengigkeit), myGBC,1,8,1,2,100,100);
    }

}