package utopp.gui.klassenframe;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

class ParameterDialog extends JDialog implements ActionListener
{
  public static final int MR_OK = 0;
  public static final int MR_CANCEL = 1; 

  public int modalResult;  
  
  // hierin passiert alles:
  private ListControlPanel jpParameter;
	
// hauptschlich Konstruktoren	

 
  // ein leerer Konstruktor wird benutzt, wenn man sowieso stndig die 
  // komplette Datengrundlage ndert.	
  public ParameterDialog(){
  	this(null, new UmlParameterListe());
  }
  
	//Konstruktor2
  public ParameterDialog(JFrame parent)
  {
    this(parent, new UmlParameterListe());
  }
	
  //Konstruktor3
  public ParameterDialog(JFrame parent, UmlParameterListe data)
  {
	
    super(parent, "Parameter", true);
	
	jpParameter = 
	  new ListControlPanel(data, new ParameterDataPanel());		

	initGUI();
		
   }
 
  
  // macht im Prinzip nur die unterliegende Methode nach oben bekannt.
  // arbeiten mit der Kopie, um Original nicht zu zerstren.
  public void setData(UmlParameterListe data){
    jpParameter.setData(data);
  }
  
  
  // Sehr wichtig: liefert die aktuellen Daten zurck  
  public UmlParameterListe getData()
  {  
     UmlParameterListe h = new UmlParameterListe();
     jpParameter.getData(h);
	 return h;
  }//end getData
    
  public Object getShowing(){
    return jpParameter.getShowing();
  } 
   
// stndig wechselnde Datengrundlage. Benutzt z.B. bei Parameter:
// Parameterdialog wird fr unterschiedliche Methoden benutzt.

    public boolean showDialog(UmlParameterListe data)
    {	
		setData((UmlParameterListe) data.clone());
	    return showDialog();
    }//end showDialog
    
    
// wird benutzt, wenn der Dialog einmal mit Daten initialisiert wird
// und dann immer nur neuere Versionen der gleichen Daten dargestellt
// werden	
    public boolean showDialog()
    {
    	show();
	    return (modalResult == MR_OK);
    }//end showDialog
    
  public void actionPerformed(ActionEvent e) 
    {	  	
	  if (e.getActionCommand().equals("Ok"))
	    modalResult = MR_OK;
	  else
	    modalResult = MR_CANCEL; 
	  
	  hide();  
	   	
    }    
 
  protected void initGUI()
  {		
    JPanel jpPane = new JPanel(new BorderLayout());	 
	this.setContentPane(jpPane);
	
	JPanel jpButtons = new JPanel(new FlowLayout());	
	jpButtons.add(ComponentFactory.getJButton("Ok",this));		
	jpButtons.add(ComponentFactory.getJButton("Abbrechen",this));	
	JPanel jpBottom = new JPanel(new BorderLayout());
	jpBottom.add(jpButtons, BorderLayout.EAST);
		
	jpPane.add(jpBottom, BorderLayout.SOUTH);
	
	jpPane.add(jpParameter, BorderLayout.NORTH);
	
	pack();
		
  }
    
  }   
