package utopp.modell;

import java.io.*;
import java.text.*;

import utopp.xml.*;

public class UmlAssoziation extends UmlObject
{
	private String sStereotyp;
	private String sZusicherung;
	private String sEigenschaften;
	
    public UmlAssoziation(String stereotyp, String name, String zusicherung, String eigenschaften){
	  super(name);
	  sStereotyp = stereotyp;
	  sZusicherung = zusicherung;
	  sEigenschaften = eigenschaften;
	}
		
	public String getStereotyp () 
	{
		return sStereotyp;
	}

	public String getZusicherung () 
	{
		return sZusicherung;
	}

	public String getEigenschaften () 
	{
		return sEigenschaften;
	}

	public void setStereotyp (String value) 
	{
		sStereotyp = value;
	}

	public void setZusicherung (String value) 
	{
		sZusicherung = value;
	}

	public void setEigenschaften (String value) 
	{
		sEigenschaften = value;
	}
	
	public String toString(){
	  return (sStereotyp==null || sStereotyp.equals(""))?getName():sStereotyp+": "+getName();
	}
	
		
	public void xmlWrite (XmlWriter o, int depth)  throws IOException
	{	  
	  o.writeTagLn("Assoziation",depth);
	  o.writeTaggedValueLn("Stereotyp",sStereotyp,depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+1);
	  o.writeTaggedValueLn("Zusicherung",sZusicherung,depth+1);
	  o.writeTaggedValueLn("Eigenschaften",sEigenschaften,depth+1);	  
	  o.writeEndTagLn("Assoziation",depth);
	  
	};
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("Assoziation"))
		  break;
		if (typ == 2)  
		{		
		    if (tag.equals("Stereotyp"))
		      sStereotyp = i.getTagValue(tag);
		    else  
		    if (tag.equals("Name"))
		      setName(i.getTagValue(tag));
		    else 			 
		    if (tag.equals("Zusicherung"))
		      sZusicherung = i.getTagValue(tag);
		    else 
		    if (tag.equals("Eigenschaften"))
		      sEigenschaften = i.getTagValue(tag);
		}  
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
	};		
	
}
