package utopp.modell;

import java.util.*;
import java.io.*;
import java.text.*;

import utopp.modell.event.*;
import utopp.xml.*;

public class UmlMultiAssoziation extends UmlAssoziation
{
	private UmlRollenListe rlRollen;
	
	public UmlMultiAssoziation(String stereotyp, String name, String zusicherung, String eigenschaften){
		super(stereotyp, name, zusicherung, eigenschaften);
		rlRollen = new UmlRollenListe();
	}
	
    public UmlMultiAssoziation(){
	  this("","","","");
	}
	
	public UmlMultiAssoziation(Object obj){
	  this();
	  if (obj instanceof UmlBinaerAssoziation)
	  {
	  	UmlBinaerAssoziation ba = (UmlBinaerAssoziation) obj;
		setStereotyp(ba.getStereotyp());
		setName(ba.getName());
		setZusicherung(ba.getZusicherung());
		setEigenschaften(ba.getEigenschaften());
		try{
		  if (ba.getRolle1()!=null) 
		    rlRollen.addWithCheck(ba.getRolle1());		
		  if (ba.getRolle2()!=null) 
		    rlRollen.addWithCheck(ba.getRolle2());
		} catch(ElementExistiertException eee){System.out.println(eee);} 		 
	  } // if
	}
			
	
	public UmlRollenListe getRollen(){
		
	  return rlRollen;	
	}
	
	public void setRollen(UmlRollenListe rollen){
		
	  rlRollen = rollen;	
	}	
	
	
	public void xmlWrite (XmlWriter o, int depth)  throws IOException
	{	  	
	  o.writeTagLn("MultiAssoziation", depth);
	  o.writeTaggedValueLn("Stereotyp",getStereotyp(),depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+1);
	  o.writeTaggedValueLn("Zusicherung",getZusicherung(),depth+1);
	  o.writeTaggedValueLn("Eigenschaften",getEigenschaften(),depth+1);
	  rlRollen.xmlWrite(o,depth+1);
	  o.writeEndTagLn("MultiAssoziation",depth);		  
	};
	
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("MultiAssoziation"))
		  break;
		if (typ == 2)  
		{ 		
		    if (tag.equals("Stereotyp"))
		      setStereotyp(i.getTagValue(tag));
		    else    
		    if (tag.equals("Name"))
		      setName(i.getTagValue(tag));
		    else 			 
		    if (tag.equals("Zusicherung"))
		      setZusicherung(i.getTagValue(tag));
		    else 
		    if (tag.equals("Eigenschaften"))
		      setEigenschaften(i.getTagValue(tag));
			else  
		    if (tag.equals("Rollenliste"))
			  rlRollen.xmlRead(i);								   					      		    
		}  
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
	  
	};		
	

}
