package utopp.modell;

import java.util.*;
import java.io.*;
import java.text.*;

import utopp.xml.*;
import utopp.modell.event.*;

public class UmlObjectListe extends Vector implements XmlDatenaustausch
{
	private String sListenName;
	private Vector objektNamen;
	
	public UmlObjectListe(){
		
	  this("Objekt", "Objektliste");
	}
	
	public UmlObjectListe(String objName, String listName){
	  super();
	  this.sListenName = listName;
	  objektNamen = new Vector();
	  this.objektNamen.add(objName);  
	}
	
	public void addObjectName(String name){
	  objektNamen.add(name);
	}
	
	public void addWithCheck(Object obj) throws ElementExistiertException  
	{
		if (!contains(obj))
		  add(obj);
		else
		   throw new ElementExistiertException(getElementExistiertMsg(obj));

	}
	
	public void addWithCheck(int index, Object obj) throws ElementExistiertException 
	{
	  if (!contains(obj))
	  	add(index, obj);
	  else
	    throw new ElementExistiertException(getElementExistiertMsg(obj));	
	}
	
	public String getElementExistiertMsg(Object obj){
	  return objektNamen.get(0) + " schon vorhanden: "+obj;
	}

	public String getElementExistiertNichtMsg(Object obj){
	  return objektNamen.get(0) + " nicht vorhanden: "+obj;
	}
		
	protected UmlObject getObject(String tag){
	  return new UmlObject("");
	}
	  			
	public void xmlWrite (XmlWriter o, int depth) throws IOException{
	 	  	
	  o.writeTagLn(sListenName, depth);
	  for(int i=0;i<size();i++)
	  	((UmlObject)get(i)).xmlWrite(o, depth+1);	  	
	  o.writeEndTagLn(sListenName, depth);
	};
		
	public void xmlRead(XmlReader i) throws IOException{
      
	  this.clear();
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals(sListenName))
		  break;
		if (typ == 2 && objektNamen.contains(tag))
		  try{ 
		  	UmlObject uo =  getObject(tag);
			uo.xmlRead(i);
		    addWithCheck(uo);
		  }catch(ElementExistiertException eee){System.out.println(eee);}		  		  	  
		
	  } // while
	  
	  } catch(ParseException pe){System.out.println(pe);};
	} //xmlRead
	
   public Object clone(){
	 UmlObjectListe h = new UmlObjectListe();
     for (int i=0;i<size();i++)
	   h.add(((UmlObject)get(i)).clone());
	 return h;  
   }  	

	
	public Vector getObjektNamen()
	{
	return this.objektNamen;
	}

	public void setObjektNamen(Vector objektNamen)
	{
	this.objektNamen = objektNamen;
	}

	
	public String getListenName()
	{
	return this.sListenName;
	}

	public void setListenName(String sListenName)
	{
	this.sListenName = sListenName;
	}
} //UmlObjectListe

