package utopp.xml;

import java.io.*;

public class XmlWriter extends OutputStreamWriter{
  
  public static String NORMAL_GAP="  ";
  
  private int iDepth;
  private String sGap;
  private String el;
  
  public XmlWriter(OutputStream o){
  	this(o,0, NORMAL_GAP);
  }
  
  public XmlWriter(OutputStream o, int depth){
   this(o, depth, NORMAL_GAP);
  }
  
  public XmlWriter(OutputStream o, String gap){
  
    super(o);
	this.el="";
	if (gap!=null)
	{
	  this.iDepth = gap.length();
	  this.sGap = gap;
	}
	else
	{
		this.iDepth = 0;
		this.sGap="";
	}
	
  }
  
  public XmlWriter(OutputStream o, int depth, String el){  
    super(o);
    this.iDepth = depth;
	this.el = el;
	if (el!=null)
      this.sGap = XmlFactory.getGap(el, iDepth);
	else
	  this.sGap = "";
  }
  
  public String getRelGap(int off){
    return sGap+XmlFactory.getGap(el, off);
  }

  public void write(String text) throws IOException{
    write(text, 0, text.length());	
  }
  
  public void writeLn(String text, int off) throws IOException{
  	this.write(getRelGap(off)+text+XmlFactory.NEXT_LINE);
  //	write(13); write(10);
  	// );
  }
  
  public void writeTag(String name) throws IOException{
    write(XmlFactory.getTag(name));
  }
  
  public void writeTagLn(String name, int off) throws IOException{
    writeLn(XmlFactory.getTag(name), off);
  }
  
  public void writeTagLn(String name) throws IOException{
    writeLn(XmlFactory.getTag(name),0);
  }

  public void writeEndTag(String name) throws IOException{
    write(XmlFactory.getEndTag(name));
  }
        
  public void writeEndTagLn(String name, int off) throws IOException{
    writeLn(XmlFactory.getEndTag(name),off);
  }
  
  public void writeEndTagLn(String name) throws IOException{
    writeLn(XmlFactory.getEndTag(name),0);
  }  
   
  public void writeTaggedValue(String tagName, String value) throws IOException{ 
  	write(XmlFactory.getTaggedValue(tagName, value));
  }
        
  public void writeTaggedValueLn(String tagName, String value, int off) throws IOException{ 
  	writeLn(XmlFactory.getTaggedValue(tagName, value),off);
  }
	    
  public void writeTaggedValueLn(String tagName, String value) throws IOException{
  	writeLn(XmlFactory.getTaggedValue(tagName, value),0);
  }
}